/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-06 at 21:27:02 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.coordinate.model;

/**
 * A job.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Maps Coordinate API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Job extends com.google.api.client.json.GenericJson {

  /**
   * Job id.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.math.BigInteger id;

  /**
   * List of job changes since it was created. The first change corresponds to the state of the job
   * when it was created.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<JobChange> jobChange;

  static {
    // hack to force ProGuard to consider JobChange used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(JobChange.class);
  }

  /**
   * Identifies this object as a job.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Current job state.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private JobState state;

  /**
   * Job id.
   * @return value or {@code null} for none
   */
  public java.math.BigInteger getId() {
    return id;
  }

  /**
   * Job id.
   * @param id id or {@code null} for none
   */
  public Job setId(java.math.BigInteger id) {
    this.id = id;
    return this;
  }

  /**
   * List of job changes since it was created. The first change corresponds to the state of the job
   * when it was created.
   * @return value or {@code null} for none
   */
  public java.util.List<JobChange> getJobChange() {
    return jobChange;
  }

  /**
   * List of job changes since it was created. The first change corresponds to the state of the job
   * when it was created.
   * @param jobChange jobChange or {@code null} for none
   */
  public Job setJobChange(java.util.List<JobChange> jobChange) {
    this.jobChange = jobChange;
    return this;
  }

  /**
   * Identifies this object as a job.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Identifies this object as a job.
   * @param kind kind or {@code null} for none
   */
  public Job setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Current job state.
   * @return value or {@code null} for none
   */
  public JobState getState() {
    return state;
  }

  /**
   * Current job state.
   * @param state state or {@code null} for none
   */
  public Job setState(JobState state) {
    this.state = state;
    return this;
  }

  @Override
  public Job set(String fieldName, Object value) {
    return (Job) super.set(fieldName, value);
  }

  @Override
  public Job clone() {
    return (Job) super.clone();
  }

}
