/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-06 at 21:27:02 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.coordinate.model;

/**
 * Change to a job. For example assigning the job to a different worker.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Maps Coordinate API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class JobChange extends com.google.api.client.json.GenericJson {

  /**
   * Identifies this object as a job change.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Change applied to the job. Only the fields that were changed are set.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private JobState state;

  /**
   * Time at which this change was applied.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.math.BigInteger timestamp;

  /**
   * Identifies this object as a job change.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Identifies this object as a job change.
   * @param kind kind or {@code null} for none
   */
  public JobChange setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Change applied to the job. Only the fields that were changed are set.
   * @return value or {@code null} for none
   */
  public JobState getState() {
    return state;
  }

  /**
   * Change applied to the job. Only the fields that were changed are set.
   * @param state state or {@code null} for none
   */
  public JobChange setState(JobState state) {
    this.state = state;
    return this;
  }

  /**
   * Time at which this change was applied.
   * @return value or {@code null} for none
   */
  public java.math.BigInteger getTimestamp() {
    return timestamp;
  }

  /**
   * Time at which this change was applied.
   * @param timestamp timestamp or {@code null} for none
   */
  public JobChange setTimestamp(java.math.BigInteger timestamp) {
    this.timestamp = timestamp;
    return this;
  }

  @Override
  public JobChange set(String fieldName, Object value) {
    return (JobChange) super.set(fieldName, value);
  }

  @Override
  public JobChange clone() {
    return (JobChange) super.clone();
  }

}
